/**************************************************
** GAME KEYBOARD CLASS
**************************************************/
var Keys = function(up, left, right, down, space) {
	var up = up || false,
		left = left || false,
		right = right || false,
		down = down || false,
		space = space || false;
		/* these were variables I was tinkering with to create different firing modes
		 * (single-shot, burst mode).
		 * in the end, even though they worked, it felt more fun to just be able to blast bullets
		 * everywhere you want, so they aren't being used for now.
		readyToFire = readyToFire || true,
		shotsFired = shotsFired || 0;
		*/
		
	var onKeyDown = function(e) {
		var that = this,
			c = e.keyCode;
		switch (c) {
			// Controls
			case 37: // Left
			case 65: // A
				that.left = true;
				break;
			case 38: // Up
			case 87: // W
				that.up = true;
				break;
			case 39: // Right
			case 68: // D
				that.right = true; // Will take priority over the left key
				break;
			case 40: // Down
			case 83: // S
				that.down = true;
				break;
			case 32: // Space Bar
				that.space = true;
				break;
		};
	};
	
	var onKeyUp = function(e) {
		var that = this,
			c = e.keyCode;
		switch (c) {
			case 37: // Left
			case 65: // A
				that.left = false;
				break;
			case 38: // Up
			case 87: // W
				that.up = false;
				break;
			case 39: // Right
			case 68: // D
				that.right = false;
				break;
			case 40: // Down
			case 83: // S
				that.down = false;
				break;
			case 32: // Space Bar
				that.space = false;
				break;
		};
	};
	
	// the listener for this is disconnected, so it won't get called at all.
	// it was being used as a way to alter firing behavior.
	// body commented out just to be sure it never gets executed for now.
	var onKeypress = function(e) {
		/*
		var that = this,
			c = e.keyCode;
		switch(c) {
			case 32: // Space Bar
			if (readyToFire) {
				that.space = true;
				that.readyToFire = false;
			};
			break;
		};
		*/
	};

	return {
		up: up,
		left: left,
		right: right,
		down: down,
		space: space,
		onKeyDown: onKeyDown,
		onKeyUp: onKeyUp
	};
};